#include <bits/stdc++.h>
using namespace std;
ifstream fin("graunte.in");
ofstream fout("graunte.out");

const int NMAX = 5005;
const int MOD = 1789;

int n, q1, q2;
long long matrice[NMAX][NMAX];
long long sumaLinie[NMAX];

long long gcd(long long a, long long b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

long long sumaCoprime(int x) {
    long long suma = 0;
    for (int i = 1; 2 * i <= x; i++) {
        if (gcd(x, i) == 1) {
            if (2 * i != x) {
                suma = (suma + x) % MOD;
            } else {
                suma = (suma + i) % MOD;
            }
        }
    }
    return suma;
}

void update(int a, int b, int c, int d, int v) {
    long long w = sumaCoprime(v);
    
    for (int i = a; i <= c; i++) {
        for (int j = b; j <= d; j++) {
            matrice[i][j] += w;
        }
    }
}

void calculSumaLinie() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sumaLinie[i] += matrice[i][j];
        }
    }
}

pair<int, int> obtineCeaMaiLungaSecventaDeLinii(long long sumaMaxima) {
    int primaLinieBest = -1, ultimaLinieBest = -1;

    for (int primaLinie = 1; primaLinie <= n; primaLinie++) {
        long long suma = 0;
        for (int ultimaLinie = primaLinie; ultimaLinie <= n; ultimaLinie++) {
            suma += sumaLinie[ultimaLinie];
            if (suma <= sumaMaxima) {
                if (primaLinieBest == -1 || ultimaLinie - primaLinie > ultimaLinieBest - primaLinieBest) {
                    primaLinieBest = primaLinie;
                    ultimaLinieBest = ultimaLinie;
                }
            } else {
                break;
            }
        }
    }

    return {primaLinieBest, ultimaLinieBest};
}

int main() {
    fin >> n >> q1 >> q2;

    while (q1--) {
        int a, b, c, d, v;
        fin >> a >> b >> c >> d >> v;
        update(a, b, c, d, v);
    }

    calculSumaLinie();

    while (q2--) {
        long long k;
        fin >> k;

        pair<int, int> raspuns = obtineCeaMaiLungaSecventaDeLinii(k);
        fout << raspuns.first << " " << raspuns.second << "\n";
    }

    return 0;
}
