#include <bits/stdc++.h>
using namespace std;
ifstream fin("graunte.in");
ofstream fout("graunte.out");

const int NMAX = 5000;
const int VMAX = 5005;
const int MOD = 1789;

int n, q1, q2;
long long mars[NMAX][NMAX];
long long sumaLinie[NMAX];
int sumaCoprime[VMAX];

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int getSumaCoprime(int x) {
    int suma = 0;
    for (int i = 1; i <= x - i; i++) {
        if (gcd(x, i) == 1) {
            if (i < x - i) {
                suma = (suma + x) % MOD;
            }
            else {
                suma = (suma + i) % MOD;
            }
        }
    }
    return suma;
}

void update(int a, int b, int c, int d, int v) {
    int w = sumaCoprime[v];
    
    mars[a][b] += w;
    mars[a][d + 1] -= w;
    mars[c + 1][b] -= w;
    mars[c + 1][d + 1] += w;
}

void calculSumaLinie() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            sumaLinie[i] += mars[i][j];
        }
    }
}

pair<int, int> obtineCeaMaiLungaSecventaDeLinii(long long sumaMaxima) {
    int primaLinieBest = -1, ultimaLinieBest = -1;

    for (int primaLinie = 1; primaLinie <= n; primaLinie++) {
        long long suma = 0;
        for (int ultimaLinie = primaLinie; ultimaLinie <= n; ultimaLinie++) {
            suma += sumaLinie[ultimaLinie];
            if (suma <= sumaMaxima) {
                if (primaLinieBest == -1 || ultimaLinie - primaLinie > ultimaLinieBest - primaLinieBest) {
                    primaLinieBest = primaLinie;
                    ultimaLinieBest = ultimaLinie;
                }
            } else {
                break;
            }
        }
    }

    return {primaLinieBest, ultimaLinieBest};
}

int main() {
    for (int i = 1; i < VMAX; i++) {
        sumaCoprime[i] = getSumaCoprime(i);
    }

    fin >> n >> q1 >> q2;

    while (q1--) {
        int a, b, c, d, v;
        fin >> a >> b >> c >> d >> v;
        update(a, b, c, d, v);
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            mars[i][j] += mars[i - 1][j] + mars[i][j - 1] - mars[i - 1][j - 1];
        }
    }

    calculSumaLinie();

    while (q2--) {
        long long k;
        fin >> k;

        pair<int, int> raspuns = obtineCeaMaiLungaSecventaDeLinii(k);
        fout << raspuns.first << " " << raspuns.second << "\n";
    }

    return 0;
}
