#include <bits/stdc++.h>
#define int long long
using namespace std;
ifstream fin("graunte.in");
ofstream fout("graunte.out");

const int NMAX = 1e6 + 5;
const int VMAX = 1e6 + 5;
const int MOD = 1789;

int n, q1, q2;
int coprimeMaiMici[VMAX];
long long line_sums[NMAX];

void numaraCoprimeMaiMici() {
    for (int i = 1; i < VMAX; i++) {
        coprimeMaiMici[i] = i;
    }
    for (int i = 2; i < VMAX; i++) {
        if (coprimeMaiMici[i] == i) {
            for (int j = i; j < VMAX; j += i) {
                coprimeMaiMici[j] = 1LL * coprimeMaiMici[j] * (i - 1) / i;
            }
        }
    }
}

int calculeazaSumaCoprime(int v) {
    return (1LL * v * coprimeMaiMici[v] / 2) % MOD;
}

void adaugaPeLinii(int primaLinie, int ultimaLinie, long long valoare) {
    for (int i = primaLinie; i <= ultimaLinie; ++i) {
        line_sums[i] += valoare;
    }
}

pair<int, int> obtineCeaMaiLungaSecventaDeLinii(long long k) {
    pair<int, int> raspuns = {-1, -1};
    int bestLength = 0;

    int primaLinie = 1;
    long long sum = 0;

    for (int ultimaLinie = 1; ultimaLinie <= n; ultimaLinie++) {
        sum += line_sums[ultimaLinie];
        while (primaLinie <= ultimaLinie && sum > k) {
            sum -= line_sums[primaLinie];
            primaLinie++;
        }

        if (primaLinie > ultimaLinie) {
            continue;
        }

        int currentLength = ultimaLinie - primaLinie + 1;
        if (currentLength > bestLength || (currentLength == bestLength && primaLinie < raspuns.first)) {
            bestLength = currentLength;
            raspuns = {primaLinie, ultimaLinie};
        }
    }

    return raspuns;
}

signed main() {
    fin >> n >> q1 >> q2;

    numaraCoprimeMaiMici();

    while (q1--) {
        int a, b, c, d, v;
        fin >> a >> b >> c >> d >> v;

        long long w = calculeazaSumaCoprime(v);
        long long plusLinie = (d - b + 1) * w;
        adaugaPeLinii(a, c, plusLinie);
    }

    while (q2--) {
        long long k;
        fin >> k;

        pair<int, int> raspuns = obtineCeaMaiLungaSecventaDeLinii(k);
        fout << raspuns.first << " " << raspuns.second << "\n";
    }

    return 0;
}
